#ifndef GFX_HPP
#define GFX_HPP

#include "global.hpp"

// Draws the background of the playground (grid plus frame over)
void draw_grid(HDC dc);

namespace button {
    enum type { white, gray, white_pressed };
}

// Draws a button of the specified type at the specified position
// (0,0) is the top left corner, (24, 24) is lower right
void draw_button(HDC, button::type t, int x, int y);

// Draws a robot facing dir at the specified pos in th grid
// (0,0) is top/left, (24, 24) is bottom/right
void draw_robot(HDC, direction::type dir, int x, int y);

// Draws a "wall" (uncrossable spot) at the specified position
void draw_wall(HDC, int x, int y);

// Draws a trail line from given position in the given direction
void draw_trail(HDC, int x, int y, direction::type t);

// Draws a directed wall from given position in the given direction
void draw_wall(HDC, int x, int y, direction::type t);

#endif // GFX_HPP
