#include <cctype>

#include "parser.hpp"

#define YYSTYPE void*
#include "parser.tab.hpp"

extern int yyparse();

extern YYLTYPE yylloc;

namespace parser {
    int error_loc;
	bool success;
	std::list<function>* program;
	int (*get_char)(int* p);
    int current_char_pos;
	bool yyparse(std::list<function>* out)
	{ current_char_pos=0; program=out; success=true; ::yyparse(); return success; }
}

int yyerror(char const* ch)
{
    parser::error_loc=parser::current_char_pos;
	parser::success=false;
	return 1;
}

int yylex()
{
    int i=0;

    yylloc.start=parser::current_char_pos;
    yylloc.end=parser::current_char_pos+1;

	int const c=parser::get_char(&i);

	if(c>=256){
	    yylval=(void*)i;
	    yylloc.end=yylloc.start+c-256;
	    parser::current_char_pos+=c-256;
	    return NUMBER;
	}

	parser::current_char_pos++;

	if(std::isdigit(c)) {
		yylval=(void*)(c-'0');
		return NUMBER;
	}

	if(c=='s' || c=='l' || c=='r') return c;

	yylval=reinterpret_cast<void*>((int)c);

	if(std::islower(c)) return FUNC_NAME;

	if(std::isupper(c)) return ARG;
	return c;
}
